//+------------------------------------------------------------------+
//|                                                #_s_Neuro_Kox.mq4 |
//|                                          Copyright  2006, klot. |
//|                                                     klot@mail.ru |
//+------------------------------------------------------------------+
//| #_s_Neuro_Kox_TRO_MODIFIED_VERSION                               |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"

#property indicator_chart_window  // TRO
#property  indicator_buffers 1    // TRO


#include <stdlib.mqh>
//---
#include <WinUser32.mqh>
//---
#import "#_lib_Neuro_Koh.ex4"
void NeuroNet_SOM(string NameWW, double in[], double& ww[][], double& Out_Net[], int Nk, 
                                                   bool Tranning=false, double myu=0.0001);
int StrSplit(string source, string& dest[], string delimeter = ";");
void InNormalize(double& aa[]);
#import
//---
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
   string Name_Net1="Script;1440;11"; //   
   //---
   double in_neuro[];
   double Koh_WW1[1440][11]; // ()   Wi *  Nj 
   double Out_Net1[]; //  1
   int M,Nk;
   //-----------------------------------------------------------------+
   int Vj;
   
   double VjBuffer[];    // TRO
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
 {
   SetIndexStyle(0, DRAW_NONE); // TRO
   SetIndexBuffer(0, VjBuffer); // TRO
   
   Name_Net1= Symbol()+Period()+"Script;1440;11";  
    
   //---
   string Net_param[3];
   
   int count=StrSplit(Name_Net1,Net_param,";");
   if (count!=3)
   {
      Print("    ");
      return(0);
   }
   //---
   M=1440/Period();
   Nk=StrToInteger(Net_param[2]);
   //---
   ArrayResize(in_neuro,M);
   //---
   History_Pattern(0.00001);
   //---
  return(0);
 }
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   //----------------------------------------------------------------------------+
   //|                                                       |
   //----------------------------------------------------------------------------+
   
   if ( Bars<1440/Period() ) return(0);
   //---
   datetime begin_time, cur_time;
   int      nbar_day, begin_bar,cur_bar;
   int i;
   //---
   cur_time=iTime(NULL,0,0);
   nbar_day=iBarShift(NULL,PERIOD_D1,cur_time);
   //---
   begin_time=iTime(NULL,PERIOD_D1,nbar_day);
   begin_bar=iBarShift(NULL,0,begin_time);
   //---
   //---
   //Comment("M= ",M," begin_bar= ",begin_bar);
   //---
   ArrayInitialize(in_neuro,0.0);
   //---
   if( begin_bar>10 )
   {
         for( i=0; i<=begin_bar-1; i++)
         {
            in_neuro[i]=iClose(NULL,0,begin_bar-i)-iOpen(NULL,PERIOD_D1,nbar_day);
         }
    //---
    InNormalize(in_neuro);
    }
    //Comment(" in_neuro[0]= ",in_neuro[0], " in_neuro[1]= ",in_neuro[1],
    //       " in_neuro[2]= ",in_neuro[2], " in_neuro[3]= ",in_neuro[3]);
   //----------------------------------------------------------------------------+
   //|                                                               |
   //----------------------------------------------------------------------------+
   NeuroNet_SOM(Name_Net1,in_neuro,Koh_WW1,Out_Net1,Nk,false,0);
   //---
   
   Vj=ArrayMaximum(Out_Net1);
   //---
   VjBuffer[0] = Vj; // TRO   
//   Comment("Vj= ",Vj, "   VjBuffer[0] = ", DoubleToStr(VjBuffer[0],Digits) ); // TRO

   
    //  ObjectCreate(" "+Time[begin_bar]+" ", OBJ_TEXT, 0, Time[begin_bar-(M/2)], High[begin_bar-(M/2)] );
    //  ObjectSetText(" "+Time[begin_bar]+" ", " "+Vj, 30, "Times New Roman", Red);
   //---
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//----------------------------------------------------------------------------+
//|                                                          |
//----------------------------------------------------------------------------+ 
void History_Pattern(double muy=0.0001)
{
   int Vjt;
   datetime start_time,some_time,cur_time;
   int start_bar, shift, begin, nbar_day, count;
   //---
   cur_time=iTime(NULL,0,0);
   nbar_day=iBarShift(NULL,PERIOD_D1,cur_time);
   //---
   start_time=iTime(NULL,0,iBars(NULL,0)-1);
   start_bar=iBarShift(NULL,PERIOD_D1, start_time);
   //---
   for( shift=start_bar-1; shift>=nbar_day+1; shift--)
   {
      some_time=iTime(NULL,PERIOD_D1,shift);
      begin=iBarShift(NULL,0,some_time);
      //---
      for(int i=0; i<=M-1; i++)
         {
            in_neuro[i]=iClose(NULL,0,begin-i)-iOpen(NULL,PERIOD_D1,nbar_day);
         }
      //---
      InNormalize(in_neuro);
      //---
      NeuroNet_SOM(Name_Net1,in_neuro,Koh_WW1,Out_Net1,Nk,true,muy);
      //---
      Vjt=ArrayMaximum(Out_Net1);
      //---
      //ObjectCreate(" "+Time[begin]+" ", OBJ_TEXT, 0, Time[begin-(M/2)], High[begin-(M/2)] );
      //ObjectSetText(" "+Time[begin]+" ", " "+Vjt, 30, "Times New Roman", Yellow);
      //---
      count++;
   }
   //Print( "    ",TimeToStr(start_time,TIME_DATE|TIME_SECONDS) );
   //Print( "    ",TimeToStr(some_time,TIME_DATE|TIME_SECONDS) ,"  = ",count );
   
   //---
   return;
}
//+------------------------------------------------------------------+

