//+--------------------------------------------------------------+
//| Thread_Hist_1.mq4 |
//| Based on Spudfyre's Thread theory |
//| Display Stochastics rainbow based on different periods. |
//| |
//| emda |
//+--------------------------------------------------------------+
//| |
//| Remake for Alert-Signal"X" by kamita |
//+--------------------------------------------------------------+
//| Thread_Hist_1_EXT_TRO                                            |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
#property copyright "Copyright ? 2007, Spudfyre & Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"
//----
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 3

#property indicator_color1 DarkGray
#property indicator_width1 3

#property indicator_color2 Blue
#property indicator_width2 3

#property indicator_color3 OrangeRed

#property indicator_level1 10.0
#property indicator_level2 15.0
#property indicator_level3 0
#property indicator_level4 0
#property indicator_levelcolor Gray

//---- input parameters



extern double Limit = 3.0;

//---- buffers
double BufferDelta[];
double Buffer_UP[];
double Buffer_DN[];




double sl1, psl1 ;
double sl2, psl2 ;
double sl3, psl3 ;
double swa, pswa ;
double su1, psu1 ;
double su2, psu2 ;
double su3, psu3 ;

int win ;
string short_name;

string ArrowHeadRt =  "" ; // 216 up arrow head
string ArrowHeadUp =  "" ; // 217 up arrow head
string ArrowHeadDn =  "" ; // 218 up arrow head 
string TAG = "tHiSt" ;

bool   Above, Below, xAbove, xBelow, goingUp, goingDn;

bool   bswaover, bslover, bsuover, bsl1over, bsl2over, bsl3over, bsu1over, bsu2over, bsu3over ;

string swaarrow, slarrow, suarrow, sl1arrow, sl2arrow, sl3arrow, su1arrow, su2arrow, su3arrow ;

color  swacolor, slcolor, sucolor, sl1color, sl2color, sl3color, su1color, su2color, su3color ;
 
//+--------------------------------------------------------------+
int init()
{
IndicatorBuffers(8);
SetIndexStyle(0, DRAW_HISTOGRAM);
SetIndexBuffer(0, BufferDelta);

SetIndexBuffer(1, Buffer_UP);
//SetIndexStyle(1, DRAW_LINE);
SetIndexStyle(1, DRAW_ARROW);
SetIndexArrow(1, 251);

SetIndexStyle(2, DRAW_NONE);
SetIndexBuffer(2, Buffer_DN);
SetIndexArrow(2, 251);

//---- name for DataWindow and indicator subwindow label

short_name="Thread_Hist_Alert";
IndicatorShortName(short_name);
SetIndexLabel(0, "MPS wall");

deinit();

return(0);
}
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}
    
//+------------------------------------------------------------------+
int deinit()
{
   Comment("") ;
       
   ObDeleteObjectsByPrefix(TAG);  
   
   TRO() ;
   
   return(0);
}

//-----------------------------------------------------------

int start()
{

win = WindowFind(short_name); 

int counted_bars=IndicatorCounted();
if (counted_bars<0) return(-1);

if (counted_bars>0) counted_bars--;
int pos=Bars-counted_bars;

//---- main calculation loop

while(pos>=0)
{

    psu1 = su1 ;
    psu2 = su2 ;
    psu3 = su3 ;
    psl1 = sl1 ;
    psl2 = sl2 ;
    psl3 = sl3 ;
    pswa = swa ;

    sl1 = iStochastic(NULL,0,5,3,3,0,0,0,pos);
    sl2 = iStochastic(NULL,0,9,3,3,0,0,0,pos);
    sl3 = iStochastic(NULL,0,11,3,3,0,0,0,pos);
    swa = iStochastic(NULL,0,14,3,3,0,0,0,pos);
    su1 = iStochastic(NULL,0,17,3,3,0,0,0,pos);
    su2 = iStochastic(NULL,0,20,3,3,0,0,0,pos);
    su3 = iStochastic(NULL,0,24,3,3,0,0,0,pos);

double smatrix[7];

smatrix[0]=su1;
smatrix[1]=su2;
smatrix[2]=su3;
smatrix[3]=swa;
smatrix[4]=sl1;
smatrix[5]=sl2;
smatrix[6]=sl3;



DoCross( sl1, psl1, pswa, bsl1over, sl1arrow, sl1color)  ;
 
DoCross( sl2, psl2, pswa, bsl2over, sl2arrow, sl2color)  ;
 
DoCross( sl3, psl3, pswa, bsl3over, sl3arrow, sl3color)  ;
 
DoCross( su1, psu1, pswa, bsu1over, su1arrow, su1color)  ;
 
DoCross( su2, psu2, pswa, bsu2over, su2arrow, su2color)  ;
 
DoCross( su3, psu3, pswa, bsu3over, su3arrow, su3color)  ;
 
DoCross( swa, pswa, pswa, bswaover, swaarrow, swacolor)  ; 



bslover = bsl1over && bsl2over && bsl3over ;
bsuover = bsu1over && bsu2over && bsu3over ;


double maxstoch = smatrix[ArrayMaximum(smatrix)];
double minstoch = smatrix[ArrayMinimum(smatrix)];

BufferDelta[pos] = maxstoch - minstoch;
Buffer_UP[pos]   = EMPTY_VALUE ;

if( BufferDelta[pos] < Limit )
{
   Buffer_UP[pos] = 80 ;
   Buffer_DN[pos] = 0 ;
   
   if( psu3 < su3 ) { Buffer_DN[pos] = 20 ; } 
   if( psu3 > su3 ) { Buffer_DN[pos] = 80 ; }
} // if

pos--;


DoShowLegend() ;

}
return(0);
}
//+--------------------------------------------------------------+ 

void DoCross( double curr, double prev, double threshold, bool & cBOOL, string & cARROW  , color & cCOLOR )  
{
goingUp  = curr > prev ;
goingDn  = curr < prev ; 

Above    = curr > threshold ;
Below    = curr < threshold ;

xAbove   = prev < threshold && curr > threshold ;
xBelow   = prev > threshold && curr < threshold ; 

if(Above) { cBOOL = true  ; cARROW = ArrowHeadUp ;  cCOLOR = Green ; return(0) ;}
if(Below) { cBOOL = false ; cARROW = ArrowHeadDn ;  cCOLOR = Red   ; return(0) ;}

}
 
//+------------------------------------------------------------------+  
void DoShowLegend()
{ 
   int yIncL = 0;

   setObject("u3","24,3,3  " ,30,yIncL,su3color); 
   setObject("ut3",su3arrow,10,yIncL,su3color     ,"Wingdings");
   yIncL = yIncL + 10;


   setObject("u2","20,3,3  " ,30,yIncL,su2color); 
   setObject("ut2",su2arrow,10,yIncL,su2color     ,"Wingdings");
   yIncL = yIncL + 10;


   setObject("u1","17,3,3  " ,30,yIncL,su1color); 
   setObject("ut1",su1arrow,10,yIncL,su1color     ,"Wingdings");
   yIncL = yIncL + 10;

   setObject("s1","14,3,3  " ,30,yIncL,swacolor); 
   setObject("st1",swaarrow,10,yIncL,swacolor     ,"Wingdings");
   yIncL = yIncL + 10;


   setObject("l3","11,3,3  " ,30,yIncL,sl3color); 
   setObject("lt3",sl3arrow,10,yIncL,sl3color     ,"Wingdings");
   yIncL = yIncL + 10;

   setObject("l2","9,3,3   " ,30,yIncL,sl2color); 
   setObject("lt2",sl2arrow,10,yIncL,sl2color     ,"Wingdings");
   yIncL = yIncL + 10;

   setObject("l1","5,3,3   " ,30,yIncL,sl1color); 
   setObject("lt1",sl1arrow,10,yIncL,sl1color     ,"Wingdings");
   yIncL = yIncL + 10;
   
} // void

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
      labelName = TAG + labelName ;
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSet(labelName,OBJPROP_CORNER,1);
       ObjectSetText(labelName,text,size,font,theColor);
}

//+------------------------------------------------------------------+
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

  
//+--------------------------------------------------------------+ 

/*

Comment(
"su1 " , DoubleToStr(su1,Digits) , " ", bsu1over , "\n" ,
"su2 " , DoubleToStr(su2,Digits) , " ", bsu2over , "\n" ,
"su3 " , DoubleToStr(su3,Digits) , " ", bsu3over , "\n" , 
"swa " , DoubleToStr(swa,Digits) ,  "\n" , 
"sl1 " , DoubleToStr(sl1,Digits) , " ", bsl1over , "\n" ,
"sl2 " , DoubleToStr(sl2,Digits) , " ", bsl2over , "\n" ,
"sl3 " , DoubleToStr(sl3,Digits) , " ", bsl3over , "\n" ,


 
"") ;  
 
 
*/